

addlang "russian"
encoding system iso8859-1

putlog "-"
putlog "Beginning of a loading IRC-Arena client."
putlog "-"

set arenadir "scripts/mc/"

### 
## Use: .chanset #channel +arena
setudef flag arena
source ${arenadir}mc.ctools.tcl


proc mc:bn:setbinds {} {
  
  rmbind "mc:bn:*" {msg msgm pub pubm bot part sign kick nick join rejn splt}
  if {[set chan [mc:bn:chan]] == "0"} {
    putlog "!!!Warning!!! No arena-channel! No bind sets!"
	 putlog "Use: \002.chanset #channel +arena\002 to set channel."
    return
  }
  
#  bind msg - !reg														mc:bn:reg
#  bind msg - !ident													mc:bn:ident
  bind msgm - * 														mc:bn:msg
  bind pubm - "$chan !*"											mc:bn:pub
 
  bind part - "$chan *"                             		mc:bn:spart
  bind sign - "$chan *"                             		mc:bn:ssign
  bind kick - "$chan *"                             		mc:bn:skick
  bind nick - "$chan *"                             		mc:bn:snick
  bind join - "$chan *"                             		mc:bn:sjoin
  bind rejn - "$chan *"                             		mc:bn:srejn
  bind splt - "$chan *"                             		mc:bn:ssplt


  bind bot S ab_privmsg												mc:bn:privmsg
  bind bot S ab_pubmsg												mc:bn:pubmsg
  bind bot S ab_pushmode											mc:bn:pushmode
  bind bot S ab_qpushmode											mc:bn:qpushmode  
  bind bot S ab_notice												mc:bn:privnot

  putlog "Binds initalized on chan $chan"
}

proc mc:bn:init {} {
  set hostbot [userlist b&S]
#  putlog "HB: $hostbot"
  if {$hostbot == ""} {
    putlog "!!!Warning!!! Server bot not found!"
	 putlog "Use: \002.chattr botnick +S\002 to set server bot."
	 return
  }
  if {[llength $hostbot] > 1} {
	 putlog "!!!Warning!!! Several bots have +S flag! \($hostbot\)"
	 set hostbot [lindex $hostbot 0]
  }
  putlog "Server bot nick: $hostbot"
}

proc mc:bn:chan {} {
  foreach chan [channels] {
	 if {[channel get $chan arena] == "1"} {
		return $chan
	 }
  }
  return 0
}

proc mc:bn:nick {} {
  upvar n n
  upvar uh uh
  set uh [join [lindex [split [split $uh] "@"] 1]]
  return [ms:fl "${n}@$uh"]
}

proc mc:bn:pushmode {fb c t} {
  if {[set chan [mc:bn:chan]] == "0"} return
  set t [unbotnet $t]  
  pushmode $chan [lindex $t 0] [ms:dfl [lindex [split [lindex $t 1] :] 0]]
}

proc mc:bn:qpushmode {fb c t} {
  if {[set chan [mc:bn:chan]] == "0"} return
  set t [unbotnet $t]  
  putquick "MODE $chan :[lindex $t 0] [ms:dfl [lindex [split [lindex $t 1] :] 0]]"
}  

proc mc:putbot {cm txt} {
  # TODO: check for links to bot
  set hostbot [lindex [userlist b&S] 0]
#  putlog "TOBOT>>$hostbot>> $cm $txt" 
  putbot $hostbot [tobotnet [ms:fl "$cm $txt"]]
  
}

proc mc:bn:privmsg {bn c t} {
  set t [unbotnet $t]
#  putlog "PRIV>> $t"
  putquick "PRIVMSG [ms:dfl [lindex [split $t :] 0]] :[ms:dfl [lrange $t 1 end]]"  
}

proc mc:bn:privnot {bn c t} {
  set t [unbotnet $t]
#  putlog "PRIVNOT>> $t"
  putquick "NOTICE [ms:dfl [lindex [split $t :] 0]] :[ms:dfl [lrange $t 1 end]]"  
}  

proc mc:bn:pubmsg {bn c t} {
  if {[set chan [mc:bn:chan]] == "0"} return
  set t [unbotnet $t]
  putquick "PRIVMSG $chan :[ms:dfl $t]"
}

proc mc:bn:msg {n uh h t} {
#  putlog "msg:: $n :: $t"
#  set cmm [string tolower [join [lindex [split $t] 0]]]
#  if {$cmm == "!reg" || $cmm == "!ident"} return  
  mc:putbot ab_privmsg "[mc:bn:nick] $t"
}

proc mc:bn:pub {n uh h c t} {
  if {[set chan [mc:bn:chan]] == "0"} return
  if {$c != $chan} return
#  putlog "pub:: $n :: $t"
  set cmm [string tolower [join [lindex [split $t] 0]]]
  if {$cmm == "!pub" } {
	 mc:putbot ab_saymsg  "[mc:bn:nick] [join [lreplace [split $t] 0 0]]"
  } {
    mc:putbot ab_pubmsg  "[mc:bn:nick] $t"
  }  
}

proc mc:bn:reg {n uh h t} {
#  putlog "tryreg:: $n :: $t"
  mc:putbot ab_tryreg "[mc:bn:nick] $t"
}

proc mc:bn:ident {n uh h t} {
  mc:putbot ab_tryident "[mc:bn:nick] $t"
}

proc mc:bn:spart {n uh h c {m ""}} { mc:putbot ab_part [mc:bn:nick] }
proc mc:bn:ssign {n uh h c r}      { mc:putbot ab_part [mc:bn:nick] }
proc mc:bn:skick {n uh h c t r}    { mc:putbot ab_part [mc:bn:nick] }
proc mc:bn:ssplt {n uh h c}        { mc:putbot ab_part [mc:bn:nick] }
proc mc:bn:srejn {n uh h c}        { mc:putbot ab_join [mc:bn:nick] }
proc mc:bn:sjoin {n uh h c}        { mc:putbot ab_join [mc:bn:nick] }                         
proc mc:bn:snick {n uh h c nn}     { mc:putbot ab_part [mc:bn:nick]; mc:putbot ab_join [mc:bn:nick] }
   
mc:bn:setbinds
#mc:bn:init

putlog "-"
putlog "IRC-Arena client is loaded."  
