
proc mc:game:livlist {{com "*"}} {
  global liv

  if { $com == "*" } { return [array names liv] }
  set ret ""
  foreach id [array names liv] {
    if { [mc:reg:getstat comnum $id] == $com } { lappend ret $id }
  }
  return $ret
}

proc mc:game:xlivlist {notcom {def ""}} {
  global liv
  set ret ""
  foreach id [array names liv] {
    if { [mc:reg:getstat comnum $id] != $notcom } { lappend ret $id }
  }
  if { $ret == "" } { return $def }
  return $ret
}

proc mc:mrun {n uh h t} {
    global mcs mc ct cth mcr mcc mce ts tl ti tv th ta tg te todo liv param prc
    global col
    global allowwield

    set id [mc:makeid $n]

    if {![mc:check $id 1]} { return }
    if {![info exists liv($id)]} { return }
    if {[string first "run" $todo($id)] != -1} { return }
    set todo($id) [lappend todo($id) "run"]
    mc:msg $n $ct(37)
    if { $prc($id) != 0 } {
        mc:game:dolist add-do $id
#        mc:say [xformat $ct(36) [mc:getstat sex $id] [ms:dfl [mc:getstat nick $id]]]
        set prc($id) 0
        mc:checkend
    }
    set todo($id) [lsort -ascii $todo($id)]
    logtime 0
    putlog [ms:dfl "todo\($col(red)[mc:getstat nick $id]$col(cl)\) = $col(mag)$todo($id)$col(cl)"]
    logtime 1
}

proc mc:plist {n uh h c t} {
    global mcs mc ct cth mcr mcc mce ts tl ti tv th ta tg te todo liv param lastlist mcoptions

    set id [mc:makeid $n]

    if {![mc:check $id 1]} { return }
    if {[info exist lastlist] && $lastlist > [clock seconds]} { return }

    set mcoptions(sendlist) 1
    foreach ls [mc:list [mc:modeok $id "exlist"]] { mc:msg $n $ls }
    set mcoptions(sendlist) 0

    set lastlist [expr [clock seconds] + $mc(lastlist)]
}

proc mc:mclear {n uh h t} {
    global mc ct cth mcr mcc mce todo liv param prc killed
    global cleardo interval isize
    global col
    global allowwield

    set id [mc:makeid $n]

    if { ![mc:check $id 1] } { return }
    if { ![info exists liv($id)] } { return }
    ###    !  
    if { [info exist killed($id)] && $killed($id) == 1 } { return }
    if {[array exist allowwield] && [info exist allowwield($id)]} {
      mc:msg $n $ct(dow3)
      return
    }

    if { $prc($id) == 0 } {
#      mc:say [xformat $ct(clearm) [mc:getstat sex $id] [nohighlight [ms:dfl [mc:getstat nick $id]]]]
       mc:game:dolist add-clear $id
    }

    set prc($id) [mc:getstat roundprc $id]
    set newtodo ""
    foreach dodo $todo($id) {
      if { [lindex $dodo 0] == "l" } {
        lappend newtodo $dodo
        set prc($id) [expr $prc($id) - [lindex $dodo 1]]
      }
    }
    set todo($id) $newtodo


    mc:msg $n [format $ct(clearo) $prc($id)]

    ###       
    if { $cleardo($id) > 0 } {
        incr cleardo($id) -1
        cleartimers
        incr isize
        if { $isize == 0 } { incr isize }
        mc:killghost
    }
    logtime 0
    putlog [ms:dfl "todo\($col(red)[mc:getstat nick $id]$col(cl)\) = $col(mag)CLEAR$col(cl)"]
    logtime 1
}

proc mc:mdo {n uh h t} {
    global mc mcs ct cth ctdo mcr mcc mce ts tl ti twis tv th ta tg te todo liv param nnick prc killed oldtodo
    global skill _skill
    global thicoll
    global col
    global allowwield

    proc mc:do:error {errtype {data ""}} {
      global ct
      upvar n n
      array set phras $ct(doerrors)
      if { [info exist phras($errtype)] } {
        mc:msg $n [format $phras($errtype) $data]
      } {
        mc:msg $n [format $errtype $data]
      }
      return "return"
    }

    proc mc:do:correctwho {} {
      global mc ct liv
      upvar who who
      upvar n   n

      if { ![isnumber $who] } {
        if { [lsearch -exact $mc(list) [mc:makeid $who]] == -1 } {
          mc:do:error targbad $who
          set who 0
        } else {
          set who [lsearch -exact $mc(list) [mc:makeid $who]]
          incr who
        }
      } elseif { $who < 1 || $who > [array size liv] } {
        mc:do:error targbadnum $who
        set who 0
      }
      set who [expr $who - 1]
      if { $who >= 0 } {
        set who [lindex $mc(list) $who]
        return 1
      }
      return 0
    }

    set id [mc:makeid $n]

    if { ![mc:check $id 1] } { return }
    if { ![info exists liv($id)] } { return }
    ###    !  
    if { [info exist killed($id)] && $killed($id) == 1 } { return }

    if { [llength $t] != 1 && $prc($id) <= 0 } { [mc:do:error noprc] }

###   !do m :)
    if { [tolower [lindex [split $t] 1]] == "m" } {
       set mid [mc:magic:correctid [mc:tolat [tolower [join [lindex [split $t] end]]]] $id]
       if { ![mc:magic:exist $mid] } { [mc:do:error magnoexist $mid] }

       mc:magic:checkempty $id
       set name [mc:magic:getname $mid]
       #     ?
       set level -1
       foreach mag [mc:getstat magic $id] {
         if { [lindex $mag 0] == $mid } {
           set level [lindex $mag 1]
           break
         }
       }
       if { $level == -1 } { [mc:do:error magdontrnown $name] }

       ###      !do n,   
       set magnum 0
       foreach dodo $todo($id) {
         if { [lindex $dodo 0] == "n" && [tolower [lindex [split $t] 1]] != "n" } {
           [mc:do:error magnon]
         } elseif { [lindex $dodo 0] == "m" } {
           incr magnum
         }
       }
       if { $magnum >= [set maxcast [max 1 [mc:getstat maxcast $id]]] } { [mc:do:error maxcast $maxcast] }

       ###      
       set proh ""
       foreach tmcol [mc:collprohibitions $id nospell $mid] {
         lappend proh [format $cth(do.no.spe) [mc:wgetcoll $tmcol name]]
       }
       if { $proh != "" } { [mc:do:error magprohcol [join $proh ", "]] }

       ###     
       if { [mc:magic:getstat targ $mid] || (![mc:magic:getstat no-self $mid] && [mc:magic:getstat no-other $mid] && [mc:magic:getstat no-team $mid]) } { set targ 1 } { set targ 0 }

       if { [llength $t] == 5 } {
         set aprc [lindex $t 3]
         set who  [lindex $t 2]
       } elseif { [llength $t] == 4 && $targ } {
         set aprc $prc($id)
         set who  [lindex $t 2]
       } elseif { [llength $t] == 4 && !$targ } {
         set aprc [lindex $t 2]
         set who  $n
       } elseif { [llength $t] == 3 && !$targ } {
         set aprc $prc($id)
         set who  $n
       } else {
          [mc:do:error magnotarg $name]
       }
       if { $aprc == "-" } { set aprc $prc($id) }
       if { ![isnumber $aprc] || [set aprc [expr round($aprc)]] <= 0 } { [mc:do:error prcfail $aprc] }
       if { $aprc > $prc($id) } { [mc:do:error needmoreprc $prc($id)] }
       if { !$targ } { set who $n }
       if { ![mc:do:correctwho] } { return }

       ###       
       if { ![mc:chkflag debug] } {
         if { $who == $id && [mc:magic:getstat no-self $mid] } { [mc:do:error magnoself $name] }
         if { $who != $id && [mc:reg:getstat comnum $id] == [mc:reg:getstat comnum $who] && [mc:magic:getstat no-team $mid] } { [mc:do:error magnoteam $name] }
         if { [mc:reg:getstat comnum $id] != [mc:reg:getstat comnum $who] && [mc:magic:getstat no-other $mid] } { [mc:do:error magnoother $name] }
       }

       set dotype "m"
       lappend dotype $aprc
       lappend dotype $who
       lappend dotype $mid
       lappend dotype $level

       set prc($id) [expr $prc($id) - $aprc]
       if { $targ && $id == $who } {
         set targ $ct(29as)
       } elseif { $targ } {
         set targ [format $ct(29ao) [ms:dfl [mc:getstat nick $who]]]
       } else {
         set targ ""
       }
       set out ""
       lappend out [format $ct(29a) [mc:magic:getname $mid] $targ $aprc]
       if { $prc($id) <= 0 } {
         lappend out $ct(29al)
       } {
         lappend out [format $ct(29ar) $prc($id)]
       }
       ###   ,  
       if {$ta($id) < [expr2 1 1.0 * [mc:magic:getmana $mid $id] * $aprc / 100]} { lappend out $ct(29an) }

       mc:msg $n [join $out " "]

       lappend todo($id) $dotype
       set todo($id) [lsort -ascii $todo($id)]
       if { $prc($id) == 0 } {
#         mc:say [xformat $ct(36) [mc:getstat sex $id] [nohighlight [ms:dfl [mc:getstat nick $id]]]]
         mc:game:dolist add-do $id
       }
       logtime 0
       putlog [ms:dfl "todo\($col(red)[mc:getstat nick $id]$col(cl)\) = $col(mag)$todo($id)$col(cl)"]
       logtime 1

       mc:checkend
       return 1
    }

    if { [llength $t] >= 2 } {
        set t [lreplace $t 1 1 [tolower [lindex $t 1]] ]
    }

    if { [llength $t] == 2 && [lindex $t 1] == "r" } {
        foreach dodo $todo($id) {
          if { [lindex $dodo 0] == "wield" } {
            mc:msg $n $ct(dow5)
            return
          } elseif { [lindex $dodo 0] == "l" } {
            mc:msg $n $ct(dol1)
            return
          }
        }
        set be $prc($id)
        if { [info exist oldtodo($id)] } {
            if { $prc($id) <= 0 } { set be 0 }
            set todo($id) ""
            set prc($id) [mc:getstat roundprc $id]
            foreach dd $oldtodo($id) {
                if { [lindex $dd 0] != "wield" && [lindex $dd 0] != "l" && [info exist liv([lindex $dd 2])] } {
                    lappend todo($id) $dd
                    set prc($id) [expr $prc($id) - [lindex $dd 1]]
                }
            }
        }
        set t [lindex $t 0]
        if { $prc($id) == 0 && $be != 0 } {
            mc:game:dolist add-do $id
#            mc:say [xformat $ct(36) [mc:getstat sex $id] [nohighlight [ms:dfl [mc:getstat nick $id]]]]
            mc:checkend
        }
        logtime 0
        putlog [ms:dfl "todo\($col(red)[mc:getstat nick $id]$col(cl)\) = $col(mag)$todo($id)$col(cl)"]
        logtime 1
    }

    if {[lindex [split $t] 1] == "w"} {
      foreach dodo $todo($id) {
        if {[lindex $dodo 0]=="wield"} {
          mc:msg $n $ct(dow1)
          return
        } elseif {[lindex $dodo 0]!="run"} {
          mc:msg $n $ct(dow0)
          return
        }
      }
      lappend todo($id) "wield"
      set prc($id) 0
      set allowwield($id) 1
      logtime 0
      putlog [ms:dfl "todo\($col(red)[mc:getstat nick $id]$col(cl)\) = $col(mag)$todo($id)$col(cl)"]
      logtime 1
      mc:msg $n $ct(dow2)
      mc:checkend
      return
    }

    if { [llength $t] == 1 } {
        if { $todo($id) == "" || $todo($id) == "run" } {
            mc:msg $n [format $ct(27) $prc($id)]
            return
        }
        set tout ""
        set needmana 0
        foreach dodo $todo($id) {
            switch -- [lindex $dodo 0] {
                a { set tto "$ctdo([lindex $dodo 0])\(03[lindex $dodo 1]%10\)  06[ms:dfl $nnick([lindex $dodo 2])]10" }
                p { set tto "$ctdo([lindex $dodo 0])\(03[lindex $dodo 1]%10\)  06[ms:dfl $nnick([lindex $dodo 2])]10" }
                h { set tto "$ctdo([lindex $dodo 0])\(03[lindex $dodo 1]%10\)  06[ms:dfl $nnick([lindex $dodo 2])]10" }
                n { set tto "$ctdo([lindex $dodo 0])\(03[lindex $dodo 1]%10\)" }
                m {
                  set tto "$ctdo([lindex $dodo 0]) [mc:magic:getname [lindex $dodo 3]]\(03[lindex $dodo 1]%10\)  06[ms:dfl $nnick([lindex $dodo 2])]10"
                  set tmp [expr2 1 1.0 * [mc:magic:getmana [lindex $dodo 3] $id] * [lindex $dodo 1] / 100]
                  set needmana [expr $needmana + $tmp]
                }
                s { set tto "$ctdo([lindex $dodo 0]) [lindex $skill([lindex $dodo 3]) 0]\(03[lindex $dodo 1]%10\)  06[ms:dfl $nnick([lindex $dodo 2])]10" }
                l { set tto "$ctdo([lindex $dodo 0])\(03[lindex $dodo 1]%10\)  06[ms:dfl $nnick([lindex $dodo 2])]10" }
                wield { set tto "04 10" }
                run { set tto "04   10" }
            }
            set tout [lappend tout [mc:fuck $tto]]
        }
        set tout "[mc:unfuck [format $ct(28) [join $tout ", "] $prc($id)]]"
        if {$ta($id) < $needmana } { append tout " $ct(29an)" }
        mc:msg $n $tout
        return
    }
    if { ![mc:checkin [lindex $t 1] "aphnmsl"] } {
        mc:msg $n $cth(2)
        return
    }
    set aprc -1
    set atype [lindex $t 1]
    set awho 0

    if { [llength $t] > 2 } {
        if { $atype == "n" } {
            set aprc [lindex $t 2]
        } else {
            set awho [lindex $t 2]
            if { ![isnumber $awho] && $awho == "all" } {
                set awho 0
            } elseif { ![isnumber $awho] } {
                if { [lsearch -exact $mc(list) [mc:makeid $awho]] == -1 } {
                    mc:msg $n $ct(24)
                    return
                } else {
                    set awho [lsearch -exact $mc(list) [mc:makeid $awho]]
                    incr awho
                }
            } elseif { $awho < 1 || $awho > [array size liv] } {
                mc:msg $n $ct(24)
                return
            }
            set awho [expr $awho - 1]
            if { $awho >= 0 } { set awho2 [lindex $mc(list) $awho] }
        }
    } else {
        if { $atype == "p" || $atype == "h" || $atype == "n" } {
            set awho2 $id
        } else {
            mc:msg $n $cth(2)
            return
        }
    }

    if { $atype == "n" } {
        set awho2 $id
        foreach dodo $todo($id) {
          if { [lindex $dodo 0] == "m" } {
            mc:msg $n [hfrm do rejnM]
            return
          } elseif { [lindex $dodo 0] == "n" } {
            mc:msg $n [hfrm do rejnM]
            return
          }
        }
    }

    if {$atype == "l" } {
      set aprc 10
    } elseif { [llength $t] > 3 } {
        if { [lindex $t 3] == "-" } {
            set aprc $prc($id)
        } else {
            set aprc [lindex $t 3]
        }
    } else {
        if { $aprc == -1 } {
            set aprc $prc($id)
        }
    }
    if {[isnumber $aprc]} { set aprc [expr round($aprc)] }
    if { $awho != -1 && (![isnumber $aprc] || $aprc < 1 || $aprc > $prc($id)) } {
        mc:msg $n [format $cth(2a) $prc($id)]
        return
    }
    if { $aprc == 0 } {
        mc:msg $n $cth(2b)
        return
    }

    ###      
    set proh ""

    foreach tmcol [array names thicoll] {
        if { ![mc:fullcoll $id $tmcol] } { continue }

        set isproh 0

        foreach nodo [mc:wgetcoll $tmcol nodo] {
            if { [lindex $nodo 0] != $atype || $isproh == 1 } { continue }

            switch -- $atype {
                "a" {
                    if { [lindex $nodo 1] == 0 } {
                        set proh [lappend proh [format $cth(do.no.ele) [mc:wgetcoll $tmcol name]] ]
                        set type ""
                    }
                    if { [lindex $nodo 1] == 1 } {
                        set proh [lappend proh [format $cth(do.no.ele) [mc:wgetcoll $tmcol name]] ]
                        set type " "
                    }
                    if { [lindex $nodo 1] == 2 && $awho2 == $id } {
                        set proh [lappend proh [format $cth(do.no.ele) [mc:wgetcoll $tmcol name]] ]
                        set type " "
                    }
                    if { [lindex $nodo 1] == 3 && $awho2 != $id } {
                        set proh [lappend proh [format $cth(do.no.ele) [mc:wgetcoll $tmcol name]] ]
                        set type " "
                    }

                    if { [llength $nodo] > 2 } {
                        set found ""
                        foreach e [mc:getstat eq $id] {
                            if { [lsearch -exact [mc:getstat wield $id] [lindex $e 1] ] != -1 && [lindex $e 2] == 1 } {
                                set found [lappend found $e]
                            }
                        }

                        if { $found != "" } {
                            foreach nd [lrange $nodo 2 end] {
                                set typefound 0
                                foreach weapon $found {
                                    if { [mc:wget [lindex $weapon 1] weapon $id] == [lindex $nd 0] } {
                                        set typefound 1
                                    }
                                }
                                if { $typefound == 0 } { continue }
                                if { [llength $nd] > 1 } {
                                    set pars [split [lindex $nd 1] ","]
                                    foreach wear $pars {
                                        ###         
                                        foreach weapon $found {
                                            if { [lindex $weapon 3] == $wear } {
                                                set isproh 1
                                            }
                                        }
                                    }
                                } else {
                                    ###         
                                    set isproh 1
                                }
                            }
                        }
                    } else {
                        ###           
                        set isproh 1
                    }

                    if { $isproh == 0 } {
                        set proh [lreplace $proh end end]
                    }
                }
                default {
                    if { [lindex $nodo 1] == 0 } {
                        set proh [lappend proh [format $cth(do.no.ele) [mc:wgetcoll $tmcol name]] ]
                        set type ""
                    }
                    if { [lindex $nodo 1] == 1 } {
                        set proh [lappend proh [format $cth(do.no.ele) [mc:wgetcoll $tmcol name]] ]
                        set type " "
                    }
                    if { [lindex $nodo 1] == 2 && $awho2 == $id } {
                        set proh [lappend proh [format $cth(do.no.ele) [mc:wgetcoll $tmcol name]] ]
                        set type " "
                    }
                    if { [lindex $nodo 1] == 3 && $awho2 != $id } {
                        set proh [lappend proh [format $cth(do.no.ele) [mc:wgetcoll $tmcol name]] ]
                        set type " "
                    }
                }
            }
        }
    }
    if { $proh != "" } {
        set suffix ""
        if { [llength $proh] > 1 } {
            set suffix ""
        }
        set proh [join $proh ", "]
        mc:msg $n [format $cth(do.no.col) "!do $atype" $type $suffix $proh]
        return
    }

    ###       100%
    set manaprc [mc:getstat manaprc $id]

    set dotype "$atype $aprc"
    switch -- $atype {
        l {
            foreach dodo $todo($id) {
              if { [lindex $dodo 0] == "l" } {
                mc:msg $n $cth(do.l)
                return
              }
            }

            set prc($id) [expr $prc($id) - $aprc]
            set dotype [lappend dotype $awho2]
            mc:msg $n [format $ct(do.l) [ms:dfl $nnick($awho2)] $aprc $prc($id)]
            mc:dol $id $awho2
        }
        a {
            #if {$mcr($id) == $mcr($awho2)}
            #    mc:msg $n $cth(do.a)
            #    return
            #

            set catc 0
            set alrdatt 0
            foreach dodo $todo($id) {
                if { [lindex $dodo 0] == "a" } {
                    incr catc
                    if { [lindex $dodo 2] == $awho2 } { set alrdatt 1 }
                }
            }

            set maxtarg [max 1 [mc:getstat maxtarg $id]]
            if { [mc:user:longweapon $id] == 0 && [mc:feat:checkpassiverun "wd" $id 1] != 0 } {
                set maxtarg 2
            }

            if { $catc == $maxtarg && $alrdatt == 0 } {
                mc:msg $n [format $cth(2c) $maxtarg]
                return
            }

            if { $id == $awho2 && $mc(noselfattack) } {
              mc:msg $n $ct(24a)
              return
            }
            set dotype [lappend dotype $awho2]
            set prc($id) [expr $prc($id) - $aprc]
           # if { [mc:getstat prof $id] != "l" || $catc == $maxtarg }
           # if { $catc == $maxtarg } {
                set olddd ""
                foreach dodo $todo($id) {
                    if { [lindex $dodo 0] == "a" && [lindex $dodo 2] == $awho2 } {
                        set aprc [expr $aprc + [lindex $dodo 1]]
                        set dotype "$atype $aprc $awho2"
                    } else {
                        set olddd [lappend olddd $dodo]
                    }
                }
                set todo($id) $olddd
           # }
            mc:msg $n [format $ct(25) [ms:dfl $nnick($awho2)] $aprc $prc($id)]
        }
        p {
            if { $awho >= 0 } {
                if {$mcr($id) != $mcr($awho2)} {
                    mc:msg $n $cth(do.p)
                    return
                }

                set dotype [lappend dotype $awho2]
                set prc($id) [expr $prc($id) - $aprc]
                set olddd ""
                foreach dodo $todo($id) {
                    if { [lindex $dodo 0] == "p" && [lindex $dodo 2] == $awho2 } {
                        set aprc [expr $aprc + [lindex $dodo 1]]
                        set dotype "$atype $aprc $awho2"
                    } else {
                        set olddd [lappend olddd $dodo]
                    }
                }
                set todo($id) $olddd
                mc:msg $n [format $ct(26) [ms:dfl $nnick($awho2)] $aprc $prc($id)]
            } elseif { $awho == -1 } {
                set teamsize 0
                foreach e [array names liv] {
                    if { $mcr($id) == $mcr($e) } { incr teamsize }
                }

                if { $aprc > 0 && $aprc <= $prc($id) } {
                    set ostatok [expr $aprc % $teamsize]
                    if { $ostatok == $aprc } {
                        mc:msg $n [format $cth(2a) $prc($id)]
                        return
                    }
                    set procent [expr ($aprc - $ostatok) / $teamsize]
                    set ostatok [expr $prc($id) - $procent * $teamsize]
                } elseif { $aprc < 0 && [expr abs($aprc)] <= $prc($id) } {
                    if { [expr abs($aprc) * $teamsize] > $prc($id) } {
                        mc:msg $n [format $cth(2a) $prc($id)]
                        return
                    }
                    set ostatok [expr $prc($id) - abs($aprc) * $teamsize]
                    set procent [expr abs($aprc)]
                } else {
                    mc:msg $n [format $cth(2a) $prc($id)]
                    return
                }

               # putlog "PRT ALL: prc = $prc($id), teamsize = $teamsize, procent = $procent, ostatok = $ostatok"
                foreach e [array names liv] {
                    set olddd ""
                    set dotype ""
                    if { $mcr($id) == $mcr($e) } {
                        set dotype "p $procent $e"
                        foreach dodo $todo($id) {
                            if { [lindex $dodo 0] == "p" && [lindex $dodo 2] == $e } {
                                set procen [expr [lindex $dodo 1] + $procent]
                                set dotype "p $procen $e"
                            } else {
                                set olddd [lappend olddd $dodo]
                            }
                        }
                        set todo($id) $olddd
                        set todo($id) [lappend todo($id) $dotype]
                    }
                }
                set prc($id) $ostatok
                mc:msg $n [format $ct(26b) $teamsize $procent $prc($id)]
            }
        }
        h {
            if { [mc:getstat prof $id] != "p" } {
                mc:msg $n "     ."
                return
            }
            set prc($id) [expr $prc($id) - $aprc]
            set dotype [lappend dotype $awho2]
            set olddd ""
            foreach dodo $todo($id) {
                if {([lindex $dodo 0] == "h") && ([lindex $dodo 2] == $awho2)} {
                    set aprc [expr $aprc + [lindex $dodo 1]]
                    set dotype "$atype $aprc $awho2"
                } else {
                    set olddd [lappend olddd $dodo]
                }
            }
            set todo($id) $olddd
            mc:msg $n [format $ct(29) [ms:dfl $nnick($awho2)] $aprc $prc($id)]
        }
        s {
            mc:msg $n "   ."
            return

            foreach dodo $todo($id) {
                if { [lindex $dodo 0] == "n" } {
                    mc:msg $n [hfrm do rejnN]
                    return
                }
            }
            if { [llength $t] < 5 } {
                mc:msg $n $cth(30s)
                return
            }
            foreach dodo $todo($id) {
                if { [lindex $dodo 0] == "s" } {
                    mc:msg $n $cth(31s)
                    return
                }
            }
            set mtype [mc:tolat [lindex $t 4]]
            set mfound 0
            foreach mmm [mc:getstat skill $id] {
                if { [lindex $mmm 0] == $mtype } {
                    set mfound [lindex $mmm 1]
                    break
                }
            }
            if { $mfound == 0 } {
                mc:msg $n $cth(do.no.sk)
                return
            }

            ###      
            set proh ""
            foreach tmcol [mc:collprohibitions $id noskill $mtype] {
                set proh [lappend proh [format $cth(do.no.ske) [mc:wgetcoll $tmcol name]] ]
            }
            if { $proh != "" } {
                set suffix ""
                if { [llength $proh] > 1 } {
                    set suffix ""
                }
                set proh [join $proh ", "]
                mc:msg $n [format $cth(do.no.skc) $suffix $proh]
                return
            }

            if { [mc:skill:checkflag $mtype nodos] } {
              if {[expr [mc:skill:switch $id $mtype] - 1]} {
                set frm $cth(do.skon)
              } {
                set frm $cth(do.skoff)
              }
              mc:msg $n [format $frm [lindex $skill($mtype) 0]]
              return
            }

            if { $mtype == "wd" || $mtype == "we" || $mtype == "ld" || $mtype == "le" } {
                set awho2 $id
            }
            if { ($awho2 == $id || $mcr($id) == $mcr($awho2)) && ($mtype == "wa" || $mtype == "wb" || $mtype == "wc" || $mtype == "la" || $mtype == "lb" || $mtype == "lc") } {
                mc:msg $n $cth(do.no.sk1)
                return
            }

            ###   ,  
            set nmana ""
            if { $ta($id) < [expr2 1 [lindex $_skill($mtype$mfound) 4] * $manaprc] } { set nmana $ct(29sn) }

            set dotype [lappend dotype $awho2]
            set dotype [lappend dotype $mtype]
            set dotype [lappend dotype $mfound]
            set prc($id) [expr $prc($id) - $aprc]
            mc:msg $n "[format $ct(29s) [lindex $skill($mtype) 0] [ms:dfl $nnick($awho2)] $aprc $prc($id)] $nmana"
        }
        n {
#            foreach dodo $todo($id) {
#                if { [lindex $dodo 0] == "m" || [lindex $dodo 0] == "s" } {
#                    mc:msg $n $cth(do.n)
#                    return
#                }
#            }

            set dotype [lappend dotype $awho2]
            set prc($id) [expr $prc($id) - $aprc]
            set olddd ""
            foreach dodo $todo($id) {
                if { [lindex $dodo 0] == "n" } {
                    set aprc [expr $aprc + [lindex $dodo 1]]
                    set dotype "$atype $aprc $awho2"
                } else {
                    set olddd [lappend olddd $dodo]
                }
            }
            set todo($id) $olddd
            mc:msg $n [format $ct(29c) $aprc $prc($id)]
        }
    }
    if { $awho != -1 } { set todo($id) [lappend todo($id) $dotype] }
    set todo($id) [lsort -ascii $todo($id)]
    if { $prc($id) == 0 } {
#      mc:say [xformat $ct(36) [mc:getstat sex $id] [nohighlight [ms:dfl [mc:getstat nick $id]]]]
       mc:game:dolist add-do $id
    }
    logtime 0
    putlog [ms:dfl "todo\($col(red)[mc:getstat nick $id]$col(cl)\) = $col(mag)$todo($id)$col(cl)"]
    logtime 1

    mc:checkend
    return 1
}

proc mc:checkend {} {
    global mc mcs ct mcr mcc mce ts tl ti tv th ta tg te todo liv param nnick prc oldtodo
    global col

    set theend 1

    foreach id [array names liv] {
        if { $prc($id) != 0 } {
            set theend 0
        }
    }
    if { $theend == 1 } {
        cleartimers
        mc:game:dolist flush
        mc:say [format $ct(round4) $mc(tbeforeround)]
        putlog "$col(red)PRE-ROUND $mc(tbeforeround) SECONDS$col(cl)"
        utimer $mc(tbeforeround) { mc:roundend }
    }
}

proc mc:mstat {n uh h t} {
    global mcs mc ct mcr mcc mce ts tl ti twis tv th ta tg te todo liv param nnick

    set id [mc:makeid $n]

    if {![mc:check $id -]} { return }

    if {$mc(phase) == 0 || ([array exists liv] && ![info exists liv($id)])} {
        mc:msg $n "$ct(21) [mc:gethark $id]"
        return
    }

    if {$mc(phase) < 1} { return }
    set id [mc:makeid $n]

    if {![info exists liv($id)]} { return }
    if {[mc:getstat prof $id] == "w"} {
        mc:msg $n "$ct(21) [format $ct(20w) $te($id) $th($id) [mc:getstat maxhp $id] $ta($id) [mc:getmaxmp $id] [mc:getstat bonus $id] $ts($id) [mc:getstat rstr $id] $tl($id) [mc:getstat rdex $id] $twis($id) [mc:getstat rwis $id] $ti($id) [mc:getstat rint $id] $tv($id) [mc:getstat rcon $id]]"
    } else {
#        mc:msg $n "$ct(21) [format $ct(20)  $te($id) $th($id) [mc:getstat maxhp $id] $ta($id) [mc:getmaxmp $id] [mc:getstat bonus $id] $ts($id) [mc:getstat rstr $id] $tl($id) [mc:getstat rdex $id] $twis($id) [mc:getstat rwis $id] $ti($id) [mc:getstat rint $id] $tv($id) [mc:getstat rcon $id]]"
        mc:msg $n "$ct(21) [format $ct(20) $te($id) $th($id) [mc:getstat maxhp $id] $ta($id) [mc:getmaxmp $id] [mc:getstat bonus $id] [mc:getstat gstr $id] [mc:getstat rstr $id] [mc:getstat gdex $id] [mc:getstat rdex $id] [mc:getstat gwis $id] [mc:getstat rwis $id] [mc:getstat gint $id] [mc:getstat rint $id] [mc:getstat gcon $id] [mc:getstat rcon $id]]"
    }
}

proc mc:_massmsg {nks txt {isnotice 0}} {
  global mc
  set mnick ""
  foreach n $nks {
	 if {[mc:ondcc $n] || [mc:onbotnet $n] || !$mc(massmsg)} {
	   foreach ls $txt {
		  if { $isnotice } {
			 mc:notice $n $ls
		  } {
			 mc:msg $n $ls
		  }
		}
    } {
		lappend mnick $n
	 }
  }
	 
  foreach {n1 n2 n3 n4 n5} $mnick {
    set ddd [join "$n1 $n2 $n3 $n4 $n5" ","]
    foreach ls $txt {
      if { $isnotice } {
        putquick "NOTICE [ms:dfl "$ddd :$ls"]"
      } elseif { [mc:checkflag "F"] } {
        putquick "PRIVMSG [ms:dfl "$ddd :$ls"]"
      } else {
        putserv "PRIVMSG [ms:dfl "$ddd :$ls"]"
      }
    }
  }
}

proc mc:start {} {
    global mcs mc ct mcr mcc mce mcoptions mctemp
    global ts tl ti twis tv th ta tg te
    global todo liv param nnick prc roundstart livnumber mcnt oldtodo countt countr
    global cleardo interval isize
    global col

    set mc(phase) 1

    putlog " "
    putlog "$col(red)ROUND BEGIN$col(cl)"

    set out [format $ct(round2) [mc:adjending [expr abs($countr) + 1]] ]
    if { $countr > 0 } {
        set out "$out [format $ct(round6) [clock format [expr [unixtime] - $countt - 3600*3 + $mc(timeshift)] -format "%M:%S"] ]"
    }
    mc:say $out

    mc:game:dolist init

    mc:magic:autoupdate

    mc:weather:set

    mc:createlist

    if {[mc:istotal]} { mc:tot:startround $mc(list) }
    set mcoptions(sendlist) 1

    set mctemp(roundwarning) 0

    cleartimers
    set roundstart [clock seconds]
    set livnumber [array size liv]

    set listtosend ""
    set elisttosend ""
    set directsend ""
    foreach e [array names liv] {
        if { [mc:ondcc $e] } {
            set directsend [lappend directsend $e]
        } else {
            if {[mc:modeok $e "exlist"]} {
              set elisttosend [lappend elisttosend $e]
            } else {
              set listtosend [lappend listtosend $e]
            }
        }
        if { [mc:ondcc $e] || [mc:chkflag sendstat] || [mc:onbotnet $e] } {
          mc:msg [ms:dfl $e] [format $ct(cstat) $th($e) $ta($e)]
        }
        set todo($e) ""
        set prc($e) [mc:getstat roundprc $e]
        set quited($e) 2
        set cleardo($e) 1
    }
    if {$mc(massmsg)} { set mtmp "\(mass\)" } { set mtmp "" }
    logtime 0
    putlog "$col(hcyn)DirectSend$col(hblk):$col(cl) $directsend$col(cl)"
    putlog "$col(cyn)ListToSend$col(hblk)$mtmp :$col(cl) $listtosend$col(cl)"
    putlog "$col(cyn)eListToSend$col(hblk)$mtmp:$col(cl) $elisttosend$col(cl)"
    logtime 1

    foreach id $directsend {
        set list [mc:list [mc:modeok $id "exlist"]]
        set nn [ms:dfl $id]
        foreach ls $list {
            mc:msg $nn [ms:dfl "$ls"]
        }
    }
#    putlog "MassMSG: $mc(massmsg)"
    if { $mc(massmsg) == 1 } {
      if {$listtosend!=""} {
        mc:_massmsg $listtosend [mc:list 0]
      }
      if {$elisttosend!=""} {
        mc:_massmsg $elisttosend [mc:list 1]
      }
    } else {
        foreach nck [array names liv] {
            set list [mc:list [mc:modeok $nck "exlist"]]
            set nck [ms:dfl $nck]
            foreach ls $list {
                mc:msg $nnick($nck) [ms:dfl "$ls"]
            }
        }
    }

    set mcoptions(sendlist) 0

    putlog "$col(cyn)End of list sending.$col(cl)"
    logtime off
    putlog "-"
    logtime on

    set asize [max [array size liv] $mc(avegamers)]
    set interval [expr2 0 $mc(avegamers) * 1.0 / log($asize / 4.0) ]
    set interval [max 8 $interval]
    set isize    [max 9 [array size liv]]

    mc:killghost
}

proc mc:tlist {} {
    global mc

    set i 30
    while {$i > 0} {
        set i2 [max $i $mc(avegamers)]
        set int [expr2 0 $mc(avegamers) * 1.0 / log($i2 * 1.0 / 5)]
        set isize [max $$i 10]
        putlog "[format "%.2d  * %.2d . == %.3d    %s" $i $int [expr $int * $isize] [clock format [expr $int * $isize] -format "\(%M:%S\)"]]"
        incr i -1
    }
}

proc mc:getdescript {id flag} {
   if {$flag} {
	  set pr [mc:getstat profcolor $id]
	  if {$pr == ""} { set pr "\003\002\002" } { set pr "\003$pr" }
     set remort [mc:getstat remort $id]
     set lvl [mc:getstat level $id]
     if {$remort != 0} { set pr "$pr$remort/" }
     return "$pr$lvl"
   } else {
     return ""
   }
}

proc mc:list {flag} {
    global mc mcs mcr mce ct cth liv

    set list ""
    set temp ""

    for { set i 0 } { $i < [llength $mc(list)] } { incr i } {
        set id [lindex $mc(list) $i]
        if { $mc(multilist) == 1 && [string length $temp] >= 360 } {
            set temp [join $temp]
            if {[lindex $temp end]==$ct(listdel)} {
              set temp [lreplace $temp end end]
            }
            set temp [ms:dfl $temp]
            set list [lappend list "12: $temp 14"]
            set temp ""
        }
        set temp [lappend temp "03[expr $i + 1].10[mc:getstat nick $id][mc:getdescript $id $flag]"]
        if { $i < [expr [llength $mc(list)] - 1] && $mcr($id) != $mcr([lindex $mc(list) [expr $i + 1]]) } {
          if { [mc:reg:getstat isnocom [lindex $mc(list) [expr $i + 1]]] } {
            set temp [lappend temp $ct(listdelnc)]
          } {
            set temp [lappend temp $ct(listdel)]
          }
        }
    }
    if { $temp != "" } {
        set temp [join $temp]
        if {[lindex $temp end]==$ct(listdel)} { set temp [lreplace $temp end end] }
#        set temp [string trimright $temp " $ct(listdel)"]
        set temp [ms:dfl $temp]
        set list [lappend list "12: $temp 14"]
    }

    return $list
}


###          
proc mc:game:dolist {action {id "-"}} {
    global ct
    global dolist

    switch -- $action {
        "init" {
            set dolist ""
        }
        "add-do" {
            if { $id == "-" } { return }
            mc:game:dolist del $id
            lappend dolist "$id do"
            mc:timer -start dolist 2 { mc:game:dolist flush }
        }
        "add-clear" {
            if { $id == "-" } { return }
            mc:game:dolist del $id
            lappend dolist "$id clear"
            mc:timer -start dolist 1 { mc:game:dolist flush }
        }
        "del" {
            if { $id == "-" } { return }
            set newlist ""
            foreach rec $dolist {
                if { $id != [lindex $rec 0] } {
                    lappend newlist $rec
                }
            }
            set dolist $newlist
        }
        "flush" {
            if { $dolist == "" } { return }
            set idlist1 ""
            set idlist2 ""
            set nklist1 ""
            set nklist2 ""
            foreach idr $dolist {
              set id [lindex $idr 0]
              if { [lindex $idr 1] == "do" } {
                lappend idlist1 $id
                lappend nklist1 [nohighlight [mc:getstat nick $id]]
              } else {
                lappend idlist2 $id
                lappend nklist2 [nohighlight [mc:getstat nick $id]]
              }
            }
            if { $idlist1 == "" } {
              set out ""
            } elseif { [llength $idlist1] == 1 } {
              set out [xformat $ct(36) [mc:getstat sex $idlist1] [ms:dfl $nklist1]]
            } else {
              set out [format $ct(36a) [ms:dfl [mc:smartjoin $nklist1 $ct(36j1) $ct(36j2)]]]
            }

            if { $out != "" && $idlist2 != "" } { append out " " }
            if { [llength $idlist2] == 1  } {
              append out [xformat $ct(clearm) [mc:getstat sex $idlist2] [ms:dfl $nklist2]]
            } elseif { $idlist2 != "" } {
              append out [format $ct(clearmo) [ms:dfl [mc:smartjoin $nklist2 $ct(clearm1) $ct(clearm2)]]]
            }

            mc:say $out
            set dolist ""
            mc:timer -clear dolist
        }
        default {
            putlog "!ERROR! wrong type in mc:dolist - $type, id: $id"
        }
    }
}


